; doscall.asm

; Author:
;	Yuusuke MATSUO
;	matchy@quality.co.jp
;
;	Junichiro ITOH
;	itojun@foretune.co.jp / itojun@mt.cs.keio.ac.jp / JINnet itojun
;

; This file contains some functions to use MSDOS function calls


;	WARNING: this module is MEMORY MODEL DEPENDENT.


		.model	Large, C				; MODEL DEPEND

		.code

connamedev	db	"\DEV\"
conname		db	"CON", 00h
conspecial	dw	0


;	int	dosinit(void)

dosinit		proc	uses ds
		mov	ax, 3702h
		int	21h			; get AVAILDEV status
		
		mov	al, dl
		mov	dx, offset cs:conname
		or	al, al
		jnz	@f
		mov	dx, offset cs:connamedev
@@:
		
		push	cs
		pop	ds
		mov	ax, 3d00h
		int	21h			; open file handle
		jc	dosinit_error

		mov	bx, ax
		mov	ax, 4400h
		int	21h			; IOCTL read
		jc	dosinit_error

		test	dx, 0082h		; console output device
		jz	@f
		test	dx, 0010h		; special device(int29h)
		jz	@f
		mov	cs:conspecial, 1

@@:
		mov	ah, 3eh
		int	21h			; close file handle
		
		xor	ax, ax
		ret
		
dosinit_error:
		xor	ax, ax
		dec	ax
		ret
dosinit		endp


;	int	doswrite(buf, len)
;	char	*buf;
;	int	len;

doswrite	proc	uses ds si, buf:dword, len:word		; MODEL DEPEND
		lds	si, buf					; MODEL DEPEND
		mov	cx, len

		test	cs:conspecial, 0ffh
		jz	doswrite_normal
		
@@:
		lodsb
		int	29h			; special console write
		loop	@b

		mov	ax, len
		ret
		
doswrite_normal:
@@:
		lodsb
		mov	ah, 06h
		mov	dl, al
		int	21h			; direct console write
		loop	@b

		mov	ax, len
		ret
doswrite	endp


;	int	dosgetch(void)

dosgetch	proc
@@:
		mov	ah, 06h
		mov	dl, 0ffh
		int	21h			; direct console read
		jz	@b
		xor	ah, ah
		ret
dosgetch	endp


		end

